/****************************************************************************
 *
 * Julia set test program for PS3 cell architecture.
 *
 * (c) 2007 Ranulf Doswell <dev@ranulf.net>
 *
 * I've only been programming the PS3 for just over 24 hours and here is my
 * first attempt at just the SPUs, DMA transfers and hand-optimising SBU
 * assembler (such a nice processor to experiment with)...
 *
 * Please feel free to use this as a basis for your experimentations, but if
 * you come up with anything cool, please let me know!
 *
 ****************************************************************************/

# This is my hand-optimised (but not tidied up in the slightest) version of
# the julia set algorithm.
#
# There are probably many better ways of doing this (not least is a sensible
# register usage policy) but as I hadn't done ANY cell programming a day ago
# I'm not too upset about how it's turned out.


# This isn't actually the number of iterations, but number of times round
# the loop. As it's unrolled, this needs to be divided appropriately.
#
.equ	iterationsCount,390


	.file	"optimised.s"
.text
	.align	3
	.global	julia
	.type	julia, @function

julia:
	bi	$lr
	.size	julia, .-julia


################################################################################

# void juliaLine(u32* line =$3, int width =$4, float fx =$5, float fy =$6, float x0 =$7, float y0 =$8, float stepx_xinc =$9, float stepx_yinc =$10) 

	.align	3
	.global	juliaLine
	.type	juliaLine, @function
juliaLine:

	stqd	$lr,16($sp)
	#stqd	$sp,-240($sp)
	#ai	$sp,$sp,-240

	ori		$40,$3,0			#	$40 = line
	ori		$41,$4,0			#	$41 = width
	ori		$42,$5,0			#	$42 = fx
	ori		$43,$6,0			#	$43 = fy
	ori		$44,$7,0			#	$44 = x0
	ori		$45,$8,0			#	$45 = y0
	ori		$46,$9,0			#	$46 = stepx_xinc
	ori		$47,$10,0			#	$47 = stepx_yinc
	il	$48,0					# $48 = x counter
	il		$49,iterationsCount	# $49 = number of iterations

.loopTopLine:
	ori	$3,$42,0				# lqd	$3,144($sp)
	ori	$4,$43,0				# lqd	$4,160($sp)

#######################################################################
# cut and pasted from julia method so as to remove the brsl

	hbrr .loopBack, .loopTop				# branch hint for inner loop

	# $3=x, $4=y, $44=x0, $45=y0, $46=xinc, $47=yinc

	fa	$2,$46,$46
	fa	$2,$2,$2
	fa	$39,$3,$2					# $39 = x + 4*xinc
	fa	$37,$39,$2					# $37 = x + 8*xinc
	fa	$35,$37,$2					# $35 = x + 12*xinc

	fa	$2,$47,$47
	fa	$2,$2,$2
	fa	$38,$4,$2					# $38 = y + 4*yinc
	fa	$36,$38,$2					# $36 = y + 8*yinc
	fa	$34,$36,$2					# $34 = y + 12*yinc

	il	$2,0

	cwd		$9,0($2)
	shufb	$11,$3,$11,$9			# put value into word 0
	shufb	$12,$4,$12,$9			# put value into word 0
	shufb	$13,$44,$13,$9			# x0
	shufb	$14,$45,$14,$9			# y0
	shufb	$15,$39,$15,$9			# put value into word 0
	shufb	$16,$38,$16,$9			# put value into word 0
	shufb	$19,$37,$19,$9			# third
	shufb	$20,$36,$20,$9
	shufb	$23,$35,$23,$9			# fourth
	shufb	$24,$34,$24,$9	

	cwd		$9,4($2)
	fa	$3,$3,$46
	fa	$4,$4,$47
	shufb	$11,$3,$11,$9			# put value+xinc into word 1
	shufb	$12,$4,$12,$9			# put value+yinc into word 1
	shufb	$13,$44,$13,$9			# x0
	shufb	$14,$45,$14,$9			# y0
	fa	$39,$39,$46
	fa	$38,$38,$47
	shufb	$15,$39,$15,$9			# put x +4 into word 0
	shufb	$16,$38,$16,$9			# put y +4 into word 0
	fa	$37,$37,$46
	fa	$36,$36,$47
	shufb	$19,$37,$19,$9			# third
	shufb	$20,$36,$20,$9
	fa	$35,$35,$46
	fa	$34,$34,$47
	shufb	$23,$35,$23,$9			# fourth
	shufb	$24,$34,$24,$9	

	cwd		$9,8($2)
	fa	$3,$3,$46
	fa	$4,$4,$47
	shufb	$11,$3,$11,$9			# put value+xinc*2 into word 2
	shufb	$12,$4,$12,$9			# put value+yinc*2 into word 1
	shufb	$13,$44,$13,$9			# x0
	shufb	$14,$45,$14,$9			# y0
	fa	$39,$39,$46
	fa	$38,$38,$47
	shufb	$15,$39,$15,$9			# put x +4 into word 0
	shufb	$16,$38,$16,$9			# put y +4 into word 0
	fa	$37,$37,$46
	fa	$36,$36,$47
	shufb	$19,$37,$19,$9			# third
	shufb	$20,$36,$20,$9
	fa	$35,$35,$46
	fa	$34,$34,$47
	shufb	$23,$35,$23,$9			# fourth
	shufb	$24,$34,$24,$9	

	cwd		$9,12($2)
	fa	$3,$3,$46
	fa	$4,$4,$47
	shufb	$11,$3,$11,$9			# put value+xinc*3 into word 3
	shufb	$12,$4,$12,$9			# put value+yinc*3 into word 3
	shufb	$13,$44,$13,$9			# x0
	shufb	$14,$45,$14,$9			# y0
	fa	$39,$39,$46
	fa	$38,$38,$47
	shufb	$15,$39,$15,$9			# put x +4 into word 0
	shufb	$16,$38,$16,$9			# put y +4 into word 0
	fa	$37,$37,$46
	fa	$36,$36,$47
	shufb	$19,$37,$19,$9			# third
	shufb	$20,$36,$20,$9
	fa	$35,$35,$46
	fa	$34,$34,$47
	shufb	$23,$35,$23,$9			# fourth
	shufb	$24,$34,$24,$9	

###
	ilhu	$9,16512
	il	$7,0
	il	$8,-1
	il	$10,0

	il	$18,-1
	il	$17,0

	il	$22,-1
	il	$21,0

	il	$26,-1
	il	$25,0

# $5 = x2
# $6 = y2
# $7 = loop counter
# $8 = inclusion mask
# $9 = 4.0
# $10 = iteration count
# $11 = x
# $12 = y
# $13 = x0
# $14 = y0

# $15 = second x
# $16 = second y
# $17 = iteration count
# $18 = second inclusion mask

# $19 = third x
# $20 = third y
# $21 = iteration count
# $22 = third inclusion mask

# $23 = fourth x
# $24 = fourth y
# $25 = iteration count
# $26 = fourth inclusion mask

	ori	$13,$11,0
	ori $14,$12,0
	ori $27,$15,0
	ori $28,$16,0
	ori $29,$19,0
	ori $30,$20,0
	ori $31,$23,0
	ori $32,$24,0

# $13,$14 = x0/y0 for part 1
# $27,$28 = x0/y0 for part 2
# $29,$30 = x0/y0 for part 3
# $31,$32 = x0/y0 for part 4

.loopTop:
############################################################
# this part can be unrolled easily, the conditional branch at the end does not need copying

	fm		$5,$11,$11		# x2 = x*x
	fm		$6,$12,$12		# y2 = y*y
	fa		$2,$11,$11
	fm		$2,$2,$12
	fa		$12,$2,$14		# y = 2*x*y + y0
	fs		$2,$5,$6
	fa		$11,$2,$13		# x = x2-y2 + x0

	fa		$2,$5,$6		# $2 = x2+y2
	fcgt	$2,$9,$2		# $3 = all ones if $9 > $2 (i.e. 4.0 > x2+y2)
	and		$8,$8,$2		# $8 = all ones if pixel still valid
	sf		$10,$8,$10		# $10 = increase iteration count if still in bounds

### parallel block

	fm		$5,$15,$15		# x2 = x*x
	fm		$6,$16,$16		# y2 = y*y
	fa		$2,$15,$15
	fm		$2,$2,$16
	fa		$16,$2,$28		# y = 2*x*y + y0
	fs		$2,$5,$6
	fa		$15,$2,$27		# x = x2-y2 + x0

	fa		$2,$5,$6		# $2 = x2+y2
	fcgt	$2,$9,$2		# $3 = all ones if $9 > $2 (i.e. 4.0 > x2+y2)
	and		$18,$18,$2		# $18 = all ones if pixel still valid
	sf		$17,$18,$17		# $17 = increase iteration count if still in bounds

### parallel block

	fm		$5,$19,$19		# x2 = x*x
	fm		$6,$20,$20		# y2 = y*y
	fa		$2,$19,$19
	fm		$2,$2,$20
	fa		$20,$2,$30		# y = 2*x*y + y0
	fs		$2,$5,$6
	fa		$19,$2,$29		# x = x2-y2 + x0

	fa		$2,$5,$6		# $2 = x2+y2
	fcgt	$2,$9,$2		# $3 = all ones if $9 > $2 (i.e. 4.0 > x2+y2)
	and		$22,$22,$2		# $22 = all ones if pixel still valid
	sf		$21,$22,$21		# $21 = increase iteration count if still in bounds

### parallel block

	fm		$5,$23,$23		# x2 = x*x
	fm		$6,$24,$24		# y2 = y*y
	fa		$2,$23,$23
	fm		$2,$2,$24
	fa		$24,$2,$32		# y = 2*x*y + y0
	fs		$2,$5,$6
	fa		$23,$2,$31		# x = x2-y2 + x0

	fa		$2,$5,$6		# $2 = x2+y2
	fcgt	$2,$9,$2		# $3 = all ones if $9 > $2 (i.e. 4.0 > x2+y2)
	and		$26,$26,$2		# $26 = all ones if pixel still valid
	sf		$25,$26,$25		# $25 = increase iteration count if still in bounds
########################
# second unrolling
########################
#RPT###########################################################
	orx		$3,$8
	orx		$2,$18
	or		$3,$2,$3		# consider both cases
	orx		$2,$22
	or		$3,$2,$3		# consider both cases
	orx		$2,$26
	or		$3,$2,$3		# consider both cases

	brz		$3,.iterationFinished	# bail out early

.L2:
	cgt		$2,$7,$49
	nor		$2,$2,$2		# $2=00 if $7>max iter, all ones otherwise
	ai		$7,$7,1
	ceqbi	$2,$2,0			# $2 = FF if bytes == $0
	xsbh	$2,$2			# extend byte to half word (8->16)
.loopBack:
	brhz	$2,.loopTop

.neverFound:
	nor		$8,$8,$8		# get 0 if inside set, ones if not
	and		$10,$8,$10		# force iteration count to 0 when inside set

	nor		$18,$18,$18		# get 0 if inside set, ones if not
	and		$17,$18,$17		# force iteration count to 0 when inside set

	nor		$22,$22,$22		# get 0 if inside set, ones if not
	and		$21,$22,$21		# force iteration count to 0 when inside set

	nor		$26,$26,$26		# get 0 if inside set, ones if not
	and		$25,$26,$25		# force iteration count to 0 when inside set

.iterationFinished:

#######################################################################
	# results are in $10,$17,$21,$25

#######################################################################

	hbrr .loopBackLine, .loopTopLine		# branch hint for main loop

	fa	$2,$46,$46
	fa	$2,$2,$2				# *4
	fa	$2,$2,$2				# *8
	fa	$2,$2,$2				# *16
	fa	$42,$2,$42				# fx += stepx_xinc

	fa	$2,$47,$47
	fa	$2,$2,$2				# *4
	fa	$2,$2,$2				# *8
	fa	$2,$2,$2				# *16
	fa	$43,$2,$43				# fy += stepx_yinc

####################################

	# $3,$4,$5,$6 also known as $10,$17,$21,$25

	shli	$9,$10,4				# stqd	$4,64($sp)			# r = i<<4
	shli	$19,$17,4
	shli	$23,$21,4
	shli	$27,$25,4
	
	shli	$8,$10,2				# stqd	$4,48($sp)			# g = i<<2
	shli	$18,$17,2
	shli	$22,$21,2
	shli	$26,$25,2
#####
	andi	$2,$9,255
	shli	$3,$2,16
	
	andi	$2,$8,255
	shli	$2,$2,8
	or	$3,$3,$2

	andi	$2,$10,255
	or	$4,$3,$2
#####
	andi	$2,$19,255
	shli	$3,$2,16
	
	andi	$2,$18,255
	shli	$2,$2,8
	or	$3,$3,$2

	andi	$2,$17,255
	or	$5,$3,$2
#####
	andi	$2,$23,255
	shli	$3,$2,16
	
	andi	$2,$22,255
	shli	$2,$2,8
	or	$3,$3,$2

	andi	$2,$21,255
	or	$6,$3,$2
#####
	andi	$2,$27,255
	shli	$3,$2,16
	
	andi	$2,$26,255
	shli	$2,$2,8
	or	$3,$3,$2

	andi	$2,$25,255
	or	$2,$3,$2
#####

	stqd	$4,0($40)			# store in line[x]
	stqd	$5,16($40)			# store in line[x]
	stqd	$6,32($40)			# store in line[x]
	stqd	$2,48($40)			# store in line[x]

	ai	$40,$40,64
	ai	$48,$48,16					# now 4 at a time

.L10:
	cgt	$2,$41,$48
.loopBackLine:
	brnz	$2,.loopTopLine

	#ai	$sp,$sp,240
	lqd	$lr,16($sp)
	bi	$lr
	.size	juliaLine, .-juliaLine


	.ident	"optimised.s, (c) 2007 Ranulf Doswell"

