/****************************************************************************
 *
 * Julia set test program for PS3 cell architecture.
 *
 * (c) 2007 Ranulf Doswell <dev@ranulf.net>
 *
 * I've only been programming the PS3 for just over 24 hours and here is my
 * first attempt at just the SPUs, DMA transfers and hand-optimising SBU
 * assembler (such a nice processor to experiment with)...
 *
 * Please feel free to use this as a basis for your experimentations, but if
 * you come up with anything cool, please let me know!
 *
 ****************************************************************************/

# This is my hand-optimised (but not tidied up in the slightest) version of
# the julia set algorithm.
#
# There are probably many better ways of doing this (not least is a sensible
# register usage policy) but as I hadn't done ANY cell programming a day ago
# I'm not too upset about how it's turned out.


# This isn't actually the number of iterations, but number of times round
# the loop. As it's unrolled, this needs to be divided appropriately.
#
.equ	iterationsCount,130


	.file	"optimised.s"
.text
	.align	3
	.global	julia
	.type	julia, @function

julia:
	bi	$lr
	.size	julia, .-julia


.equ	x_1,11
.equ	y_1,12
.equ	x0_1,13
.equ	y0_1,14
.equ	cnt_1,10
.equ	inc_1,8

.equ	x_2,15
.equ	y_2,16
.equ	cnt_2,17
.equ	inc_2,18

.equ	x_3,19
.equ	y_3,20
.equ	cnt_3,21
.equ	inc_3,22

.equ	x_4,23
.equ	y_4,24
.equ	cnt_4,25
.equ	inc_4,26

.equ	x_sq_1,27
.equ	y_sq_1,28
.equ	temp_1,29

.equ	x_sq_2,30
.equ	y_sq_2,31
.equ	temp_2,32

.equ	x_sq_3,33
.equ	y_sq_3,34
.equ	temp_3,35

.equ	x_sq_4,36
.equ	y_sq_4,37
.equ	temp_4,38

# $15 = second x
# $16 = second y
# $17 = iteration count
# $18 = second inclusion mask

# $19 = third x
# $20 = third y
# $21 = iteration count
# $22 = third inclusion mask

# $23 = fourth x
# $24 = fourth y
# $25 = iteration count
# $26 = fourth inclusion mask

################################################################################

# void juliaLine(u32* line =$3, int width =$4, float fx =$5, float fy =$6, float x0 =$7, float y0 =$8, float stepx_xinc =$9, float stepx_yinc =$10) 

	.align	3
	.global	juliaLine
	.type	juliaLine, @function
juliaLine:

	stqd	$lr,16($sp)
	#stqd	$sp,-240($sp)
	#ai	$sp,$sp,-240

	ori		$40,$3,0			#	$40 = line
	ori		$41,$4,0			#	$41 = width
	ori		$42,$5,0			#	$42 = fx
	ori		$43,$6,0			#	$43 = fy
	ori		$44,$7,0			#	$44 = x0
	ori		$45,$8,0			#	$45 = y0
	ori		$46,$9,0			#	$46 = stepx_xinc
	ori		$47,$10,0			#	$47 = stepx_yinc
	il	$48,0					# $48 = x counter
	il		$49,iterationsCount	# $49 = number of iterations

.loopTopLine:
	ori	$3,$42,0				# lqd	$3,144($sp)
	ori	$4,$43,0				# lqd	$4,160($sp)

#######################################################################
# cut and pasted from julia method so as to remove the brsl

	hbrr .loopBack, .loopTop				# branch hint for inner loop

	# $3=x, $4=y, $44=x0, $45=y0, $46=xinc, $47=yinc

	fa	$2,$46,$46
	fa	$2,$2,$2
	fa	$39,$3,$2					# $39 = x + 4*xinc
	fa	$37,$39,$2					# $37 = x + 8*xinc
	fa	$35,$37,$2					# $35 = x + 12*xinc

	fa	$2,$47,$47
	fa	$2,$2,$2
	fa	$38,$4,$2					# $38 = y + 4*yinc
	fa	$36,$38,$2					# $36 = y + 8*yinc
	fa	$34,$36,$2					# $34 = y + 12*yinc

	il	$2,0

	cwd		$9,0($2)
	shufb	$x_1,$3,$x_1,$9			# put value into word 0
	shufb	$y_1,$4,$y_1,$9			# put value into word 0
	shufb	$x0_1,$44,$x0_1,$9			# x0
	shufb	$y0_1,$45,$y0_1,$9			# y0
	shufb	$x_2,$39,$x_2,$9			# put value into word 0
	shufb	$y_2,$38,$y_2,$9			# put value into word 0
	shufb	$x_3,$37,$x_3,$9			# third
	shufb	$y_3,$36,$y_3,$9
	shufb	$x_4,$35,$x_4,$9			# fourth
	shufb	$y_4,$34,$y_4,$9	

	cwd		$9,4($2)
	fa	$3,$3,$46
	fa	$4,$4,$47
	shufb	$x_1,$3,$x_1,$9			# put value+xinc into word 1
	shufb	$y_1,$4,$y_1,$9			# put value+yinc into word 1
	shufb	$x0_1,$44,$x0_1,$9			# x0
	shufb	$y0_1,$45,$y0_1,$9			# y0
	fa	$39,$39,$46
	fa	$38,$38,$47
	shufb	$x_2,$39,$x_2,$9			# put x +4 into word 0
	shufb	$y_2,$38,$y_2,$9			# put y +4 into word 0
	fa	$37,$37,$46
	fa	$36,$36,$47
	shufb	$x_3,$37,$x_3,$9			# third
	shufb	$y_3,$36,$y_3,$9
	fa	$35,$35,$46
	fa	$34,$34,$47
	shufb	$x_4,$35,$x_4,$9			# fourth
	shufb	$y_4,$34,$y_4,$9	

	cwd		$9,8($2)
	fa	$3,$3,$46
	fa	$4,$4,$47
	shufb	$x_1,$3,$x_1,$9			# put value+xinc*2 into word 2
	shufb	$y_1,$4,$y_1,$9			# put value+yinc*2 into word 1
	shufb	$x0_1,$44,$x0_1,$9			# x0
	shufb	$y0_1,$45,$y0_1,$9			# y0
	fa	$39,$39,$46
	fa	$38,$38,$47
	shufb	$x_2,$39,$x_2,$9			# put x +4 into word 0
	shufb	$y_2,$38,$y_2,$9			# put y +4 into word 0
	fa	$37,$37,$46
	fa	$36,$36,$47
	shufb	$x_3,$37,$x_3,$9			# third
	shufb	$y_3,$36,$y_3,$9
	fa	$35,$35,$46
	fa	$34,$34,$47
	shufb	$x_4,$35,$x_4,$9			# fourth
	shufb	$y_4,$34,$y_4,$9	

	cwd		$9,12($2)
	fa	$3,$3,$46
	fa	$4,$4,$47
	shufb	$x_1,$3,$x_1,$9			# put value+xinc*3 into word 3
	shufb	$y_1,$4,$y_1,$9			# put value+yinc*3 into word 3
	shufb	$x0_1,$44,$x0_1,$9			# x0
	shufb	$y0_1,$45,$y0_1,$9			# y0
	fa	$39,$39,$46
	fa	$38,$38,$47
	shufb	$x_2,$39,$x_2,$9			# put x +4 into word 0
	shufb	$y_2,$38,$y_2,$9			# put y +4 into word 0
	fa	$37,$37,$46
	fa	$36,$36,$47
	shufb	$x_3,$37,$x_3,$9			# third
	shufb	$y_3,$36,$y_3,$9
	fa	$35,$35,$46
	fa	$34,$34,$47
	shufb	$x_4,$35,$x_4,$9			# fourth
	shufb	$y_4,$34,$y_4,$9	

###
	ilhu	$9,16512
	il	$7,0
	il	$inc_1,-1
	il	$cnt_1,0

	il	$inc_2,-1
	il	$cnt_2,0

	il	$inc_3,-1
	il	$cnt_3,0

	il	$inc_4,-1
	il	$cnt_4,0

# $5 = x2
# $6 = y2
# $7 = loop counter
# $8 = inclusion mask
# $9 = 4.0
# $10 = iteration count
# $11 = x (x_1)
# $12 = y
# $13 = x0
# $14 = y0

# $15 = second x
# $16 = second y
# $17 = iteration count
# $18 = second inclusion mask

# $19 = third x
# $20 = third y
# $21 = iteration count
# $22 = third inclusion mask

# $23 = fourth x
# $24 = fourth y
# $25 = iteration count
# $26 = fourth inclusion mask

.loopTop:
############################################################
# this part can be unrolled easily, the conditional branch at the end does not need copying

	fm		$x_sq_1,$x_1,$x_1		# x2 = x*x
	fm		$x_sq_2,$x_2,$x_2		# x2 = x*x
	fm		$x_sq_3,$x_3,$x_3		# x2 = x*x
	fm		$x_sq_4,$x_4,$x_4		# x2 = x*x

	fm		$y_sq_1,$y_1,$y_1		# y2 = y*y
	fm		$y_sq_2,$y_2,$y_2		# y2 = y*y
	fm		$y_sq_3,$y_3,$y_3		# y2 = y*y
	fm		$y_sq_4,$y_4,$y_4		# y2 = y*y
	
	fa		$temp_1,$x_1,$x_1
	fa		$temp_2,$x_2,$x_2
	fa		$temp_3,$x_3,$x_3
	fa		$temp_4,$x_4,$x_4
	
	fm		$temp_1,$temp_1,$y_1
	fm		$temp_2,$temp_2,$y_2
	fm		$temp_3,$temp_3,$y_3
	fm		$temp_4,$temp_4,$y_4
	
	fa		$y_1,$temp_1,$y0_1		# y = 2*x*y + y0
	fa		$y_2,$temp_2,$y0_1		# y = 2*x*y + y0
	fa		$y_3,$temp_3,$y0_1		# y = 2*x*y + y0
	fa		$y_4,$temp_4,$y0_1		# y = 2*x*y + y0
	
	fs		$temp_1,$x_sq_1,$y_sq_1
	fs		$temp_2,$x_sq_2,$y_sq_2
	fs		$temp_3,$x_sq_3,$y_sq_3
	fs		$temp_4,$x_sq_4,$y_sq_4
	
	fa		$x_1,$temp_1,$x0_1# x = x2-y2 + x0
	fa		$x_2,$temp_2,$x0_1# x = x2-y2 + x0
	fa		$x_3,$temp_3,$x0_1# x = x2-y2 + x0
	fa		$x_4,$temp_4,$x0_1# x = x2-y2 + x0

	
	fa		$temp_1,$x_sq_1,$y_sq_1		# $temp_1 = x2+y2
	fa		$temp_2,$x_sq_2,$y_sq_2		# $temp_2 = x2+y2
	fa		$temp_3,$x_sq_3,$y_sq_3		# $temp_3 = x2+y2
	fa		$temp_4,$x_sq_4,$y_sq_4		# $temp_4 = x2+y2
	
	fcgt	$temp_1,$9,$temp_1		# $3 = all ones if $9 > $temp_1 (i.e. 4.0 > x2+y2)
	fcgt	$temp_2,$9,$temp_2		# $3 = all ones if $9 > $temp_2 (i.e. 4.0 > x2+y2)
	fcgt	$temp_3,$9,$temp_3		# $3 = all ones if $9 > $temp_3 (i.e. 4.0 > x2+y2)
	fcgt	$temp_4,$9,$temp_4		# $3 = all ones if $9 > $temp_4 (i.e. 4.0 > x2+y2)
	
	and		$inc_1,$inc_1,$temp_1		# $inc_1 = all ones if pixel still valid
	and		$inc_2,$inc_2,$temp_2		# $inc_2 = all ones if pixel still valid
	and		$inc_3,$inc_3,$temp_3		# $inc_3 = all ones if pixel still valid
	and		$inc_4,$inc_4,$temp_4		# $inc_4 = all ones if pixel still valid
	
	sf		$cnt_1,$inc_1,$cnt_1		# $cnt_1 = increase iteration count if still in bounds
	sf		$cnt_2,$inc_2,$cnt_2		# $cnt_2 = increase iteration count if still in bounds
	sf		$cnt_3,$inc_3,$cnt_3		# $cnt_3 = increase iteration count if still in bounds
	sf		$cnt_4,$inc_4,$cnt_4		# $cnt_4 = increase iteration count if still in bounds

#RPT###########################################################
	orx		$temp_1,$inc_1
	orx		$temp_2,$inc_2
	orx		$temp_3,$inc_3
	orx		$temp_4,$inc_4

	or		$temp_1,$temp_2,$temp_1
	or		$temp_3,$temp_4,$temp_3
	or		$temp_1,$temp_3,$temp_1
	
	brz		$temp_1,.iterationFinished	# bail out early

.L2:
	cgt		$2,$7,$49
	nor		$2,$2,$2		# $2=00 if $7>max iter, all ones otherwise
	ai		$7,$7,1
	ceqbi	$2,$2,0			# $2 = FF if bytes == $0
	xsbh	$2,$2			# extend byte to half word (8->16)
.loopBack:
	brhz	$2,.loopTop

.neverFound:
	nor		$inc_1,$inc_1,$inc_1		# get 0 if inside set, ones if not
	nor		$inc_2,$inc_2,$inc_2		# get 0 if inside set, ones if not
	nor		$inc_3,$inc_3,$inc_3		# get 0 if inside set, ones if not
	nor		$inc_4,$inc_4,$inc_4		# get 0 if inside set, ones if not

	and		$cnt_1,$inc_1,$cnt_1		# force iteration count to 0 when inside set
	and		$cnt_2,$inc_2,$cnt_2		# force iteration count to 0 when inside set
	and		$cnt_3,$inc_3,$cnt_3		# force iteration count to 0 when inside set
	and		$cnt_4,$inc_4,$cnt_4		# force iteration count to 0 when inside set

.iterationFinished:

#######################################################################
	# results are in $cnt_1,$cnt_2,$cnt_3,$cnt_4

#######################################################################

	hbrr .loopBackLine, .loopTopLine		# branch hint for main loop

	fa	$2,$46,$46
	fa	$2,$2,$2				# *4
	fa	$2,$2,$2				# *8
	fa	$2,$2,$2				# *16
	fa	$42,$2,$42				# fx += stepx_xinc

	fa	$2,$47,$47
	fa	$2,$2,$2				# *4
	fa	$2,$2,$2				# *8
	fa	$2,$2,$2				# *16
	fa	$43,$2,$43				# fy += stepx_yinc

####################################

	# $3,$4,$5,$6 also known as $cnt_1,$cnt_2,$cnt_3,$cnt_4

	shli	$9,$cnt_1,4				# stqd	$4,64($sp)			# r = i<<4
	shli	$x_3,$cnt_2,4
	shli	$23,$cnt_3,4
	shli	$27,$cnt_4,4
	
	shli	$8,$cnt_1,2				# stqd	$4,48($sp)			# g = i<<2
	shli	$inc_2,$cnt_2,2
	shli	$inc_3,$cnt_3,2
	shli	$inc_4,$cnt_4,2
#####
	andi	$2,$9,255
	shli	$3,$2,16
	
	andi	$2,$8,255
	shli	$2,$2,8
	or	$3,$3,$2

	andi	$2,$cnt_1,255
	or	$4,$3,$2
#####
	andi	$2,$x_3,255
	shli	$3,$2,16
	
	andi	$2,$inc_2,255
	shli	$2,$2,8
	or	$3,$3,$2

	andi	$2,$cnt_2,255
	or	$5,$3,$2
#####
	andi	$2,$23,255
	shli	$3,$2,16
	
	andi	$2,$inc_3,255
	shli	$2,$2,8
	or	$3,$3,$2

	andi	$2,$cnt_3,255
	or	$6,$3,$2
#####
	andi	$2,$27,255
	shli	$3,$2,16
	
	andi	$2,$inc_4,255
	shli	$2,$2,8
	or	$3,$3,$2

	andi	$2,$cnt_4,255
	or	$2,$3,$2
#####

	stqd	$4,0($40)			# store in line[x]
	stqd	$5,16($40)			# store in line[x]
	stqd	$6,32($40)			# store in line[x]
	stqd	$2,48($40)			# store in line[x]

	ai	$40,$40,64
	ai	$48,$48,16					# now 4 at a time

.L10:
	cgt	$2,$41,$48
.loopBackLine:
	brnz	$2,.loopTopLine

	#ai	$sp,$sp,240
	lqd	$lr,16($sp)
	bi	$lr
	.size	juliaLine, .-juliaLine


	.ident	"optimised.s, (c) 2007 Ranulf Doswell"

