/****************************************************************************
 *
 * Julia set test program for PS3 cell architecture.
 *
 * (c) 2007 Ranulf Doswell <dev@ranulf.net>
 *
 * I've only been programming the PS3 for just over 24 hours and here is my
 * first attempt at just the SPUs, DMA transfers and hand-optimising SBU
 * assembler (such a nice processor to experiment with)...
 *
 * Please feel free to use this as a basis for your experimentations, but if
 * you come up with anything cool, please let me know!
 *
 ****************************************************************************/

#include "spu.h"
#include "general.h"

Spu::Spu(spe_program_handle_t* program, void* argv, void* env) {
	spe_id = spe_create_thread(0, program, argv, env, -1, 0);
	if(spe_id == 0)
		throw InitialisationError();
}

Spu::~Spu() {
}


int Spu::join() {
	int status = 0;
	spe_wait(spe_id, &status, 0);
	return status;
}

speid_t Spu::getID() {
	return spe_id;
}

void Spu::write(int msg) {
	spe_write_in_mbox(spe_id, msg);
}

int Spu::read() {
	while(!spe_stat_out_mbox(spe_id));

	int i;
//	do {
		i=spe_read_out_mbox(spe_id);
//	} while (i>=0);
	return i;
}



